//----------------------------------------------------------------------//
// zbgL[ꗗ														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include "HKeyRec.h"
#include "UserFunc.h"
#include "UIniFile.h"
#include "Unit3.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THotKeyHelp *HotKeyHelp;

//---------------------------------------------------------------------------
__fastcall THotKeyHelp::THotKeyHelp(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormShow(TObject *Sender)
{
	UnicodeString sct = "HotKeyList";
	SetBounds(
		IniFile->ReadInteger(sct,"WinLeft",		(Screen->Width-Width)/2),
		IniFile->ReadInteger(sct,"WinTop",		(Screen->Height-Height)/2),
		IniFile->ReadInteger(sct,"WinWidth",	500),
		IniFile->ReadInteger(sct,"WinHeight",	400));

	HKeyListBox->TabWidth = (::GetDialogBaseUnits() & 0x0000ffff) * 10;
	HKeyListBox->Items->Clear();
	HKeyListBox->ItemHeight = abs(HKeyListBox->Font->Height) * 3 / 2;

	//ꗗ̓eݒ
	MaxKeystr = EmptyStr;
	for (int i=0; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		if (kp->id>=(ID_HOTQ_BASE + 1) && kp->id<=(ID_HOTQ_BASE + MAX_HOTKEY)) {
			UnicodeString dscstr;
			//
			if (!kp->description.IsEmpty())	 dscstr = kp->description;
			//R}h
			else if (!kp->command.IsEmpty()) dscstr = "R}h: " + kp->command;
			//s
			else if (!kp->exe_file[0].IsEmpty()) {
				dscstr = kp->exe_file[0];
				UnicodeString ext = ExtractFileExt(dscstr);
				if (SameText(ext, ".EXE") || SameText(ext, ".COM") || SameText(ext, ".BAT"))
					dscstr = ExtractFileName(dscstr);
				if (!kp->exe_param[0].IsEmpty()) dscstr += (" " + kp->exe_param[0]);
			}
			//ANeBu
			else if (!kp->act_class[0].IsEmpty() || !kp->act_title[0].IsEmpty() ||
					 !kp->act_tit_r[0].IsEmpty() || !kp->act_tit_m[0].IsEmpty())
			{
				if (!kp->act_class[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->act_class[0];
				if (!kp->act_title[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->act_title[0];
				if (!kp->act_tit_r[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->act_tit_r[0];
				if (!kp->act_tit_m[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->act_tit_m[0];
				dscstr = "ANeBu: " + dscstr;
			}
			//
			else if (!kp->cls_class[0].IsEmpty() || !kp->cls_title[0].IsEmpty() ||
					 !kp->cls_tit_r[0].IsEmpty() || !kp->cls_tit_m[0].IsEmpty())
			{
				if (!kp->cls_class[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->cls_class[0];
				if (!kp->cls_title[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->cls_title[0];
				if (!kp->cls_tit_r[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->cls_tit_r[0];
				if (!kp->cls_tit_m[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->cls_tit_m[0];
				dscstr = ": " + dscstr;
			}
			//ŏ
			else if (!kp->min_class[0].IsEmpty() || !kp->min_title[0].IsEmpty() ||
					 !kp->min_tit_r[0].IsEmpty() || !kp->min_tit_m[0].IsEmpty())
			{
				if (!kp->min_class[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->min_class[0];
				if (!kp->min_title[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->min_title[0];
				if (!kp->min_tit_r[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->min_tit_r[0];
				if (!kp->min_tit_m[0].IsEmpty()) dscstr += (!dscstr.IsEmpty()? "," : "") + kp->min_tit_m[0];
				dscstr = "ŏ: " + dscstr;
			}
			//̑
			else if (!kp->qx_macro.IsEmpty())	dscstr = "QX}N: " + kp->qx_macro;
			else if (!kp->sound.IsEmpty())		dscstr = "TEh: " + kp->sound;
			else if (!kp->wall_paper.IsEmpty())	dscstr = "ǎ: " + kp->wall_paper;

			UnicodeString keystr = shortcut_to_text(kp->sc_inf);
			if (Canvas->TextWidth(keystr) > Canvas->TextWidth(MaxKeystr)) MaxKeystr = keystr;
			HKeyListBox->Items->Add(keystr + "\t" + dscstr);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	UnicodeString sct = "HotKeyList";
	IniFile->WriteInteger(sct,"WinLeft",	Left);
	IniFile->WriteInteger(sct,"WinTop",		Top);
	IniFile->WriteInteger(sct,"WinWidth",	Width);
	IniFile->WriteInteger(sct,"WinHeight",	Height);
	IniFile->UpdateFile();
}

//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormPaint(TObject *Sender)
{
	//TCYύXObv`
	RECT rc = Rect(
		ClientWidth - ::GetSystemMetrics(SM_CXHSCROLL),
		ClientHeight - ::GetSystemMetrics(SM_CYVSCROLL),
		ClientWidth, ClientHeight);
	::DrawFrameControl(Canvas->Handle, &rc, DFC_SCROLL,	DFCS_SCROLLSIZEGRIP);
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormResize(TObject *Sender)
{
	Repaint();
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::HKeyListBoxDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox *)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Brush->Color = clWindow;
	cv->Font->Color  = clWindowText;
	cv->FillRect(Rect);
	int w_key = cv->TextWidth(MaxKeystr) + 32;
	UnicodeString lbuf = lp->Items->Strings[Index];
	cv->TextOut(Rect.Left + 2,     Rect.Top + 1,	get_tkn(lbuf, "\t"));
	cv->TextOut(Rect.Left + w_key, Rect.Top + 1,	get_tkn_r(lbuf, "\t"));
}

//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::CloseBtnClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

